// Generated by CoffeeScript 1.6.3
(function() {
  var defaultOptions, minify, path, through, transform, _;

  through = require('through');

  _ = require("underscore");

  minify = require("html-minifier").minify;

  path = require('path');

  defaultOptions = {
    extensions: ['tpl', 'html'],
    templateSettings: {},
    htmlMinifier: false
  };

  transform = function(options) {
    options = _.defaults(options  || {}, defaultOptions);
    return function(file) {
      var buffer, isTemplate;
      isTemplate = _.some(options.extensions, function(ext) {
        return path.extname(file) === '.' + ext;
      });
      if (!isTemplate) {
        return through();
      }
      buffer = "";
      return through(function(chunk) {
        return buffer += chunk.toString();
      }, function() {
        var compiled, html, jst;
        compiled = "";
        html = buffer.toString();
        if (options.htmlMinifier) {
          html = minify(html, options.htmlMinifier);
        }
        jst = _.template(html, void 0, options.templateSettings).source;
        compiled += "module.exports = " + jst + ";\n";
        this.queue(compiled);
        return this.queue(null);
      });
    };
  };

  module.exports = transform();

  module.exports.transform = transform;

}).call(this);
